#include "debug.h"

static char debugStage = 0;

void debugUart() interrupt 4 { //串口中断服务程序
    char dat;
    if (TI) {
        TI = 0;
    }
    if (RI) {
        RI = 0;
        dat = SBUF;
        switch (debugStage) {
        case 0:
        default:
L_Check1st:
            if (dat == '@') debugStage = 1;
            else debugStage = 0;
            break;
        case 1:
            if (dat == 'S') debugStage = 2;
            else goto L_Check1st;
            break;
        case 2:
            if (dat == 'T') debugStage = 3;
            else goto L_Check1st;
            break;
        case 3:
            if (dat == 'C') debugStage = 4;
            else goto L_Check1st;
            break;
        case 4:
            if (dat == 'I') debugStage = 5;
            else goto L_Check1st;
            break;
        case 5:
            if (dat == 'S') debugStage = 6;
            else goto L_Check1st;
            break;
        case 6:
            if (dat == 'P') debugStage = 7;
            else goto L_Check1st;
            break;
        case 7:
            if (dat == '#') //当检测到正确的用户下载命令时
                IAP_CONTR = 0x60; //复位到系统区
            else goto L_Check1st;
            break;
        }
    }
}

void debugInit(void) {
    SCON = 0x50; //设置串口为8位数据位
    TMOD = 0x00;
    AUXR = 0x40;
// 仅用于定时器为1T场景
#define DEBUG_FOSC        35000000UL
#define DEBUG_BRT         (65536 - DEBUG_FOSC / 4 / 115200)
    TH1 = DEBUG_BRT >> 8; //设置串口波特率
    TL1 = DEBUG_BRT;
    TR1 = 1;
    ES = 1;
}

char putchar(char c) {
    SBUF = c;
    while(!TI);
    TI = 0;
    return c;
}
