#include <STC8G.H>
#include "intrins.h"
#include "debug.h"
#include "stdio.h"

void UartSend(char dat) {
    SBUF = dat;
    while(!TI);
    TI = 0;
}

void UartSendStr(char *p) {
    while (*p) {
        UartSend(*p++);
    }
}

void Delay1000ms() {	//@35MHz
    unsigned char i, j, k;

    i = 178;
    j = 143;
    k = 18;
    do {
        do {
            while (--k);
        } while (--j);
    } while (--i);
}

void main() {
    char wktcl, wktch;
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;
    debugInit();
    EA = 1;
    Delay1000ms();
    WKTCL = 0xff; // 设定掉电唤醒时钟约为1秒钟
    WKTCH = 0x87;
    while (1) {
        _nop_();
        _nop_();
        Delay1000ms();
        PCON = 0x02; //MCU 进入掉电模式
        wktcl = WKTCL;
        wktch = WKTCH;
        if(wktcl == 0xff && wktch == 0x87) {
            P55 = ~P55;  // 我此时LED灯不能闪烁
        }
        
//        if(1) {
//            P55 = ~P55;  // 我此时LED灯能闪烁
//        }
        _nop_();
        _nop_();
        _nop_();
        _nop_();

        _nop_();
        _nop_();
        _nop_();
        _nop_();
    }
}


